Programming Languages Hacks

Importanti regole per linguaggi di programmazione rilevanti come Java, C, C++, C#…

  • Subscribe

  • Lettori

    I miei lettori abituali

  • Twitter

Crash Reporting in .NET

Posted by Ricibald on 6th August 2013

In your .NET windows application you can’t catch all exceptions. There are critical exceptions that leaves your application inconsistent: in this case let your app crash.

But wait… and error reports? You have two alternatives:

  • use the native Microsoft solution: Windows Error Reporting (WER). It’s not easy to customize but it’s fully integrated in Win OS (i.e. when your application freezes). Here how to use WER.
  • use an off-the-shelf crash reporting library:

Note: if your application is an ASP.NET application, just use the excellent ELMAH

Posted in .net | No Comments »

Gestione Globale e Centralizzata dell’Errore in ASP.NET

Posted by Ricibald on 30th January 2008

Tipicamente un’applicazione con interfaccia console o window la gestione globale dell’errore è piuttosto semplice.

Nel caso di interfaccia console:

static int Main(string[] args)
{
  try
  {
    // Do application logic here
    return 0;
  }
  catch (ParseCommandLineException pce)
  {
    Console.WriteLine("Usage error");
    return 27;
  }
  catch (Exception e) {
    Console.WriteLine(e);
    return 42;
  }
}

Nel caso di interfaccia WinForm:

[STAThread]
static void Main()
{
  Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(Application_ThreadException);
  Application.Run(new Form1());
}

private void button1_Click(object sender, System.EventArgs e)
{
  throw new Exception("Whoops");
}

private static void Application_ThreadException(object sender, System.Threading.ThreadExceptionEventArgs e)
{
  MessageBox.Show(e.Exception.Message);
}

Nel caso invece di applicazione web verrebbe naturale ragionare nello stesso modo, scrivendo qualcosa come:

public class MyPage : System.Web.UI.Page
{
    private string _errorMessage;
    public string ErrorMessage { get { return _errorMessage; } }
    protected new PageMaster Master { get { return (PageMaster)Page.Master; } }

    protected void Page_Error(object sender, EventArgs e)
    {
    	Exception objErr = Server.GetLastError();
        EventLog.WriteEntry("MyWebform.aspx",err,EventLogEntryType.Error);
        _errorMessage = objErr.Message;
        Server.ClearError();
        Server.Transfer(this.AppRelativeVirtualPath);
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        /* Stampa messaggio di errore se presente */
        if (this.PreviousPage != null)
        {
            MyPage previousPage = (MyPage)this.PreviousPage;
            Master.ErrorLabel = previousPage.ErrorMessage;
        }
    }
}

Ma questo comporta il seguente problema:

Poiché la pagina deve poter essere completamente reinviata, perdo tutti i valori immessi dall’utente.

In altre parole, vorrei ottenere un PostBack con il messaggio di errore, ma il PostBack non può essere riprodotto.

Potremmo pensare diverse soluzioni:

  • Si potrebbe provare a simulare il PostBack, forzando il salvataggio dei dati immessi in sessione per poi ricaricarli, ma .NET non lo permette
  • Si potrebbe inviare una risposta HTTP personalizzata con il contenuto della pagina con associati i controlli immessi, ma non funziona
  • Potremmo utilizzare AJAX per aggiornare solo la differenza di ciò che è cambiato. In questo caso funzionerebbe, ma:
    • si obbligherebbe qualunque pulsante o qualunque metodo che potrebbe scatenare un’eccezione ad essere definito dentro un UpdatePanel, cosa sconsigliata per le prestazioni
  • Invece di ricaricare la stessa pagina che ha causato l’errore potremmo eseguire una Transfer verso una pagina di errore a cui passiamo il messaggio di errore tramite CrossPagePostback. A questo punto potremmo fornire un pulsante “Torna indietro” che esegue il “Back” nella cronologia del browser. In questo caso funzionerebbe, ma:
    • Dobbiamo “fidarci” della cache del browser
    • Dobbiamo obbligare il browser a fare uso di javascript per tornare indietro
    • In presenza di precedenti aggiornamenti AJAX il pulsante “Back” crea problemi: torna indietro solo del PostBack parziale. Potremmo utilizzare soluzioni articolate, come l’uso del server control History, ma non supportato nel framework 2.0

Dopo lunghe peripezie si può arrivare per ora ad una conclusione: bisogna abbandonare l’idea di gestire l’errore nel Page_Error. E allora come fare? Analizziamo quando possono avvenire gli errori nelle pagine ASP.NET:

  • nell’inizializzazione delle pagine
  • nelle PostBack, sincrone e asincrone

Per gestire l’errore “basterebbe” mettere un try/catch in tutte le parti di tutte le pagine. Per l’inizializzazione delle pagine si potrebbe pensare di gestire eventuali eccezioni in una classe Page customizzata che fa da padre per tutte le pagine che implementeremo. Potremmo quindi utilizzare il pattern Template come segue:

public abstract class MyPage : System.Web.UI.Page
{
    private string _errorMessage;
    public string ErrorMessage { get { return _errorMessage; } }
    protected new PageMaster Master { get { return (PageMaster)Page.Master; } }

    protected abstract void Specific_Page_Load(object sender, EventArgs e);

    protected void Page_Load(object sender, EventArgs e)
    {
        /* Stampa messaggio di errore se presente */
        if (this.PreviousPage != null)
        {
            MyPage previousPage = (MyPage)this.PreviousPage;
            Master.ErrorLabel = previousPage.ErrorMessage;
        }
        try
        {
            Specific_Page_Load(sender, e);
        }
        catch(Exception objErr)
        {
            _errorMessage = objErr.Message;
        }
    }
}

public class LoginPage : MyPage
{
    protected override void Specific_Page_Load(object sender, EventArgs e)
    {
        LoadControls(); // questo potrebbe causare un errore
    }
}

Ma esiste comunque un problema:

Il client che utilizza MyPage si deve ricordare di non implementare mai il Page_Load, ma di implementare solo ed esclusivamente il Specific_Page_Load ereditato.

Vorremmo invece che l’utente non sia costretto a seguire un ordine mentale: il sistema deve gestire il controllo in modo trasparente. Per fare questo bisogna capire se esiste un metodo perno di tutti i Load, il cui fallimento comporta un fallimento di un qualunque eventuale load specializzato. Questo metodo esiste, ed è OnLoad, che richiama tutti i Page_Load (non gli OnLoad) creati seguendo il cosiddetto “Principio Di Hollywood” . Basta quindi sovrascrivere OnLoad in questo modo:

public abstract class MyPage : System.Web.UI.Page
{
    protected new PageMaster Master { get { return (PageMaster)Page.Master; } }

    protected override void OnLoad(EventArgs e)
    {
        try
        {
            base.OnLoad(e);
        }
        catch(Exception objErr)
        {
            Master.ErrorLabel = objErr.Message;
        }
    }
}

In modo analogo si può sovrascrivere il metodo perno di tutti i PostBack, RaisePostBackEvent.

Vogliamo infine perfezionare questa gestione rendendola generica e riutilizzabile.

Metto quindi a disposizione di chiunque fosse interessato la mia soluzione per la gestione globale delle eccezioni. Chi utilizzerà questa classe è sufficiente che tutte le pagine ereditino dalla vostra pagina customizzata, che a sua volta eredita dalla mia. La vostra pagina customizzata dovrà quindi implementare il metodo HandleError e il gioco è fatto.

using System;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Drawing;
using System.Reflection;

namespace GenericException
{
    /// <summary>
    /// Inoltra tutte le richieste, ma gestisce l'eccezione e consente di visualizzarla
    /// </summary>
    public abstract class ExceptionManageablePage : System.Web.UI.Page
    {
        protected abstract void HandleError(Exception exception);

        private delegate void MethodToTryCatchOneParam<Param1>(Param1 arg1);
        private delegate void MethodToTryCatchTwoParam<Param1, Param2>(Param1 arg1, Param2 arg2);

        private void ManageErrors<Param1>(MethodToTryCatchOneParam<Param1> method, Param1 arg1)
        {
            try
            {
                method(arg1);
            }
            catch (Exception ex)
            {
                HandleError(ex);
            }
        }

        private void ManageErrors<Param1, Param2>(MethodToTryCatchTwoParam<Param1, Param2> method, Param1 arg1, Param2 arg2)
        {
            try
            {
                method(arg1, arg2);
            }
            catch (Exception ex)
            {
                HandleError(ex);
            }
        }

        protected override void OnAbortTransaction(EventArgs e)
        {
            ManageErrors(base.OnAbortTransaction, e);
        }

        protected override void OnCommitTransaction(EventArgs e)
        {
            ManageErrors(base.OnCommitTransaction, e);
        }

        protected override void OnDataBinding(EventArgs e)
        {
            ManageErrors(base.OnDataBinding, e);
        }

        protected override void OnError(EventArgs e)
        {
            ManageErrors(base.OnError, e);
        }

        protected override void OnInit(EventArgs e)
        {
            ManageErrors(base.OnInit, e);
        }

        protected override void OnInitComplete(EventArgs e)
        {
            ManageErrors(base.OnInitComplete, e);
        }

        protected override void OnLoad(EventArgs e)
        {
            ManageErrors(base.OnLoad, e);
        }

        protected override void OnLoadComplete(EventArgs e)
        {
            ManageErrors(base.OnLoadComplete, e);
        }

        /// <summary>
        /// Cattura eccezioni di qualunque postback, anche asincrono tramite Ajax. Ma in questo
        /// ultimo caso anche l'HandleError deve supportare aggiornamenti asincroni (Label dentro un UpdatePanel)
        /// </summary>
        protected override void RaisePostBackEvent(IPostBackEventHandler sourceControl, string eventArgument)
        {
            ManageErrors(base.RaisePostBackEvent, sourceControl, eventArgument);
        }

    }
}

Bisogna infine dire che per i postback asincroni devo avere una gestione dell’errore che stampi un messaggio asincrono. Basta quindi inserire una label di errore con un UpdatePanel, o utilizzare una ModalPopupExtender. E ovviamente ogni consiglio è più che benvenuto!

Posted in .net | 13 Comments »

Eccezioni in C#: Critiche Progettuali

Posted by Ricibald on 23rd January 2008

In generale apprezzo come C# è stato concepito, ma una cosa che veramente non capisco è la gestione delle eccezioni.

In Java esiste la distinzione utilissima tra eccezioni checked e non. Le eccezioni checked consentono di forzare l’utilizzatore di un metodo a gestire o rilanciare solo le eccezioni dichiarate: niente di più, niente di meno. In C#, invece, tutte le eccezioni sono unchecked e questo pone il problema:

  • quali eccezioni devo gestire?
  • come forzare a sollevare solo determinati tipi di eccezione?

Si consideri infatti il codice Java:

public class Firefox {
      public void activatePlugins() {
            for(FirefoxPluginInterface plugin in this.plugins) {
                  try {
                        plugin.activate();
                  } catch (FirefoxPluginActivationException myEx) {
                        FirefoxHelper.manageActivationFromError(myEx);
                  } catch (Exception ex) {
                        FirefoxHelper.showError(ex);
                  }
           }
      }
}

public interface FirefoxPluginInterface {
     public void activate() throws FirefoxPluginActivationException;
}

Si consideri invece il codice C# analogo:

public class Firefox
{
      public void ActivatePlugins()
      {
            foreach(FirefoxPluginInterface plugin : _plugins)
            {
                  try
                  {
                        plugin.Activate();
                  }
                  catch (FirefoxPluginActivationException myEx)
                  {
                        FirefoxHelper.ManageActivationFromError(myEx);
                  }
                  catch (Exception ex)
                  {
                        FirefoxHelper.ShowError(ex);
                  }
           }
      }
}

public interface FirefoxPluginInterface {
     public void Activate();
}

Non siamo in grado di essere sicuri che tutte le persone che scriveranno plugin faranno buon uso della nostra eccezione. Speriamo in qualche modo nella bontà di chi scriverà… Una buona pezza era stata fornita nel framework 1.1 di .NET, inserendo la classe ApplicationException: in teoria l’utente che creava le proprie personali eccezioni doveva ereditare da questa classe, e non da Exception. In questo modo si era in grado di discriminare se l’eccezione apparteneva alle standard o se era una che avevamo lanciato noi. Successivamente, come riporta MSDN:

Per la maggior parte delle applicazioni, derivare le eccezioni personalizzate dalla classe Exception . L’idea iniziale di far derivare le eccezioni personalizzate dalla classe ApplicationException non ha prodotto alcun valore significativo in termini pratici.

Questa frase e questa organizzazione delle eccezioni mi lascia un po’ interdetto…

Esiste anche il problema della propagazione delle eccezioni. L’architettura di un sistema software è infatti normalmente definita a livelli o Layer: ogni livello rappresenta un diverso livello di astrazione. Il messaggio viene quindi passato attraverso vari livelli, in cui ad ogni livello eventuali errori devono essere riscritti a seconda del livello di astrazione. Ad esempio, un eccezione SQL al livello “Database” deve essere avvolta in una eccezione di livello più alto nel livello “Dominio” (ad es. una generica eccezione nella memorizzazione dei dati). In questa comunissima pratica ingegneristica abbiamo però alcuni problemi. Immaginiamo questa situazione:

try
{
}
catch (SQLException sqlEx)
{
    throw new PersistenceException("Errore nel salvataggio", sqlEx);
}
catch (Exception ex)
{
    throw new UnknownException("Errore sconosciuto durante il salvataggio nell'inserimento", ex);
}

L’eccezione PersistenceException viene ricatturata nel blocco “catch(Exception)”, comportamento assurdo in un codice Java, dove l’eccezione non sarebbe stata mai ricatturata. Per correggere questo comportamento si può eseguire un unico catch e il resto rilanciare:

try
{
}
catch (SQLException sqlEx)
{
    throw new PersistenceException("Errore nel salvataggio", sqlEx);
}
catch (Exception ex)
{
    // throw ex; NON UTILIZZARE: PERDO LO STACKTRACE!!
    throw; // OK!
}

Notare inoltre un altro problema: il “throw ex” causa la perdita di informazioni nello stacktrace: non parte più dall’origine dell’errore ma dall’origine del “throw ex”.

Realizzato il comportamento appena descritto nel codice, sarà il livello superiore che al momento della stampa del messaggio:

try
{
}
catch (Exception ex)
{
    string message = null;
    if(ex is PersistenceException) 
    {
        message = ex.Message;
    } 
    else if (ex is Exception)
    {
        message = "Errore sconosciuto durante il salvataggio nell'inserimento";
    }
    Trace.WriteLine(message);
}

Che cose articolate stranamente per realizzare un comportamento del tutto normale…

Posted in .net | 1 Comment »